Index: park_integration/AbstractFitEngine.py
===================================================================
--- park_integration/AbstractFitEngine.py	(revision f44dbc7756cb2cf8e8d1959765cc44d35f8321b5)
+++ park_integration/AbstractFitEngine.py	(revision 985c88b87a5cf7319bfda1d8af0737566479cd84)
@@ -62,5 +62,5 @@
                     self.parameters.append(param)
                    
-                    self.paramList.append(key)
+                    self.paramList.append(param_name)
             print "AbstractFitEngine: self.paramList2", self.paramList
             #A fitArrange is already created but contains dList only at Uid
Index: park_integration/test/constrainttestpark.py
===================================================================
--- park_integration/test/constrainttestpark.py	(revision 202f93a9a95b1a344da2be1c42f3270d21f697e8)
+++ park_integration/test/constrainttestpark.py	(revision 985c88b87a5cf7319bfda1d8af0737566479cd84)
@@ -34,13 +34,16 @@
         
         #Do the fit
+        model1.setParam( 'A', 1)
+        model1.setParam( 'B', 2)
+        fitter.set_model(model1,"M1",1, ['A','B'])
+        fitter.set_data(data1,1)
         
-        fitter.set_model(model1,"M1",1, {'A':1,'B':2})
-        fitter.set_data(data1,1)
-       
-        fitter.set_model(model2,"M2",2, {'A':'M1.A','B':'M1.B'})
+        model2.setParam( 'A', 'M1.A')
+        model2.setParam( 'B','M1.B')
+        fitter.set_model(model2,"M2",2, ['A','B'])
         fitter.set_data(data2,2)
     
         
-        chisqr2, out2, cov2= fitter.fit()
+        chisqr2, out2, cov2,result= fitter.fit()
         print "chisqr2",chisqr2
         print "out2", out2
@@ -77,11 +80,11 @@
         
         #Do the fit
-        
-        fitter.set_model(model1,"M1",1, {'A':1})
+        model1.setParam( 'A', 1)
+        fitter.set_model(model1,"M1",1, ['A'])
         fitter.set_data(data1,1)
        
      
         
-        chisqr2, out2, cov2 = fitter.fit()
+        chisqr2, out2, cov2,result = fitter.fit()
         print "chisqr2",chisqr2
         print "out2", out2
Index: park_integration/test/test_fitting_panel.py
===================================================================
--- park_integration/test/test_fitting_panel.py	(revision 30c6721595ac9efc1d9042a2c3144083ee977ce6)
+++ park_integration/test/test_fitting_panel.py	(revision 985c88b87a5cf7319bfda1d8af0737566479cd84)
@@ -14,5 +14,5 @@
 class testFitModule(unittest.TestCase):
     def test0(self):
-        """ test fitting for two set of data  and one model B constraint"""
+        """ test fitting for two set of data  and 2 models no constraint"""
         from sans.fit.Loader import Load
         load= Load()
@@ -38,20 +38,23 @@
         
         #Do the fit
+        model1.setParam( 'A', 1)
+        model1.setParam( 'B', 2)
+        fitter.set_model(model1,"M1",1, ['A','B'])
+        fitter.set_data(data1,1)
         
-        fitter.set_model(model1,"M1",1, {'A':1,'B':1})
-        fitter.set_data(data1,1)
-       
-        fitter.set_model(model2,"M2",2, {'A':1,'B':1})
+        model2.setParam( 'A', 1)
+        model2.setParam( 'B', 1)
+        fitter.set_model(model2,"M2",2, ['A','B'])
         fitter.set_data(data2,2)
     
         
         chisqr1, out1, cov1,result= fitter.fit()
-        self.assert_(chisqr1)
         print "chisqr1",chisqr1
         print "out1", out1
         print " cov1", cov1
+        self.assert_(chisqr1)
         
     def test01(self):
-        """ test fitting for two set of data  and one model B constraint"""
+        """ test fitting for two set of data  and 2 models and 2 constraints set on on model"""
         from sans.fit.Loader import Load
         load= Load()
@@ -77,9 +80,12 @@
         
         #Do the fit
+        model1.setParam( 'A', 1)
+        model1.setParam( 'B', 1)
+        fitter.set_model(model1,"M1",1, ['A','B'])
+        fitter.set_data(data1,1)
         
-        fitter.set_model(model1,"M1",1, {'A':1,'B':1})
-        fitter.set_data(data1,1)
-       
-        fitter.set_model(model2,"M2",2, {'A':'M1.A','B':'M1.B'})
+        model2.setParam( 'A','M1.A')
+        model2.setParam( 'B', 'M1.B')
+        fitter.set_model(model2,"M2",2, ['A','B'])
         fitter.set_data(data2,2)
     
@@ -94,5 +100,5 @@
     
     def test1(self):
-        """ test fitting for two set of data  and one model 1 constraint"""
+        """ test fitting for two set of data 2 model on constraint set on 1 model"""
         from sans.fit.Loader import Load
         load= Load()
@@ -118,9 +124,12 @@
         
         #Do the fit
+        model1.setParam( 'A',1)
+        model1.setParam( 'B',1)
+        fitter.set_model(model1,"M1",1, ['A','B'])
+        fitter.set_data(data1,1)
         
-        fitter.set_model(model1,"M1",1, {'A':1,'B':1})
-        fitter.set_data(data1,1)
-       
-        fitter.set_model(model2,"M2",2, {'A':'M1.A','B':1})
+        model2.setParam( 'A','M1.A')
+        model2.setParam( 'B', 1)
+        fitter.set_model(model2,"M2",2, ['A','B'])
         fitter.set_data(data2,2)
     
@@ -134,5 +143,5 @@
     
     def test2(self):
-        """ test fitting for two set of data  and one model no constraint"""
+        """ test fitting for two data 2 model not equal nombre of parameters fit"""
         from sans.fit.Loader import Load
         load= Load()
@@ -158,9 +167,12 @@
         
         #Do the fit
+        model1.setParam( 'A',1)
+        model1.setParam( 'B',1)
+        fitter.set_model(model1,"M1",1, ['A','B'])
+        fitter.set_data(data1,1)
         
-        fitter.set_model(model1,"M1",1, {'A':1,'B':1})
-        fitter.set_data(data1,1)
+        model2.setParam( 'A',1)
        
-        fitter.set_model(model2,"M2",2, {'A':1})
+        fitter.set_model(model2,"M2",2, ['A'])
         fitter.set_data(data2,2)
     
@@ -172,24 +184,5 @@
         self.assert_(chisqr1)
         
-        fitter= Fit('park')
-        # Receives the type of model for the fitting
-        from sans.guitools.LineModel import LineModel
-        model1  = LineModel()
-        model2  = LineModel()
-        
-        #Do the fit
-        
-        fitter.set_model(model1,"M1",1, {'A':1,'B':1})
-        fitter.set_data(data1,1)
        
-        fitter.set_model(model2,"M2",2, {'A':1,'B':None})
-        fitter.set_data(data2,2)
-    
-        
-        chisqr2, out2, cov2,result= fitter.fit()
-        print "chisqr2",chisqr2
-        print "out2", out2
-        print " cov2", cov2
-        self.assert_(chisqr2)
         
        
Index: park_integration/test/testfitting.py
===================================================================
--- park_integration/test/testfitting.py	(revision 4dd63eb2815955372311dc0d6bab3c6529bd7f57)
+++ park_integration/test/testfitting.py	(revision 985c88b87a5cf7319bfda1d8af0737566479cd84)
@@ -72,6 +72,8 @@
         
         #Do the fit SCIPY
+        model1.setParam( 'A', 2)
+        model1.setParam( 'B', 1)
         fitter.set_data(data1,1)
-        fitter.set_model(model1,"M1",1,{'A':2,'B':1})
+        fitter.set_model(model1,"M1",1,['A','B'])
         
         chisqr1, out1, cov1=fitter.fit()
@@ -85,7 +87,9 @@
         #Do the fit
         fitter.set_data(data1,1)
-        fitter.set_model(model2,"M1",1,{'A':2,'B':1})
+        model2.setParam( 'A', 2)
+        model2.setParam( 'B', 1)
+        fitter.set_model(model2,"M1",1,['A','B'])
        
-        chisqr2, out2, cov2=fitter.fit(None,None)
+        chisqr2, out2, cov2,result=fitter.fit(None,None)
         
         self.assert_(math.fabs(out2[1]-2.5)/math.sqrt(cov2[1][1]) < 2)
Index: park_integration/test/testpark.py
===================================================================
--- park_integration/test/testpark.py	(revision 4dd63eb2815955372311dc0d6bab3c6529bd7f57)
+++ park_integration/test/testpark.py	(revision 985c88b87a5cf7319bfda1d8af0737566479cd84)
@@ -40,11 +40,15 @@
         
         #Do the fit
-        fitter.set_model(model1,"M1",1, {'A':2.5,'B':4})
+        model1.setParam( 'A', 2.5)
+        model1.setParam( 'B', 4)
+        fitter.set_model(model1,"M1",1, ['A','B'])
         fitter.set_data(data1,1)
         
-        fitter.set_model(model2,"M2",2, {'A':2,'B':3})
+        model1.setParam( 'A', 2)
+        model1.setParam( 'B', 3)
+        fitter.set_model(model2,"M2",2, ['A','B'])
         fitter.set_data(data2,2)
         
-        chisqr1, out1, cov1= fitter.fit()
+        chisqr1, out1, cov1,result= fitter.fit()
         
         self.assert_(math.fabs(out1[1]-2.5)/math.sqrt(cov1[1][1]) < 2)
@@ -60,5 +64,5 @@
         
         fitter.set_data(data3,1)
-        chisqr2, out2, cov2= fitter.fit(None,None)
+        chisqr2, out2, cov2, result= fitter.fit(None,None)
         self.assert_(math.fabs(out2[1]-2.5)/math.sqrt(cov2[1][1]) < 2)
         print math.fabs(out2[0]-4.0)/math.sqrt(cov2[0][0])
@@ -98,2 +102,3 @@
         print chisqr1,chisqr2,chisqr3
         #self.assertAlmostEquals(chisqr1,chisqr2)
+        self.assert_(chisqr1)