Index: src/sas/qtgui/MainWindow/GuiManager.py
===================================================================
--- src/sas/qtgui/MainWindow/GuiManager.py	(revision d1955d675110f45de94a27bcfb2944496bed625c)
+++ src/sas/qtgui/MainWindow/GuiManager.py	(revision 8353d908545a5d1d1ac66b2e075d0ec49b5a7cc2)
@@ -86,7 +86,4 @@
         # Set up the status bar
         self.statusBarSetup()
-        # Show the Welcome panel
-        self.welcomePanel = WelcomePanel()
-        self._workspace.workspace.addSubWindow(self.welcomePanel)
 
         # Current help file
@@ -99,4 +96,5 @@
                                               "_downloads",
                                               "Tutorial.pdf"))
+
     def addWidgets(self):
         """
@@ -131,4 +129,5 @@
         self.ackWidget = Acknowledgements()
         self.aboutWidget = AboutBox()
+        self.welcomePanel = WelcomePanel()
 
         # Add calculators - floating for usability
@@ -334,4 +333,9 @@
             msg += " Please try again later."
             self.communicate.statusBarUpdateSignal.emit(msg)
+
+    def showWelcomeMessage(self):
+        """ Show the Welcome panel """
+        self._workspace.workspace.addSubWindow(self.welcomePanel)
+        self.welcomePanel.show()
 
     def addCallbacks(self):
Index: src/sas/qtgui/MainWindow/MainWindow.py
===================================================================
--- src/sas/qtgui/MainWindow/MainWindow.py	(revision 53c771ed573b1c8716ecc969b54a1d617a4cb931)
+++ src/sas/qtgui/MainWindow/MainWindow.py	(revision 8353d908545a5d1d1ac66b2e075d0ec49b5a7cc2)
@@ -1,7 +1,9 @@
 # UNLESS EXEPTIONALLY REQUIRED TRY TO AVOID IMPORTING ANY MODULES HERE
 # ESPECIALLY ANYTHING IN SAS, SASMODELS NAMESPACE
-#from PyQt4 import QtGui
-from PyQt5.QtWidgets import *
-from PyQt5.QtGui import *
+from PyQt5.QtWidgets import QMainWindow
+from PyQt5.QtWidgets import QMdiArea
+from PyQt5.QtWidgets import QSplashScreen
+from PyQt5.QtWidgets import QApplication
+from PyQt5.QtGui import QPixmap
 
 # Local UI
@@ -71,8 +73,11 @@
     # Show the main SV window
     mainwindow = MainSasViewWindow()
-    mainwindow.show()
+    mainwindow.showMaximized()
 
     # no more splash screen
     splash.finish(mainwindow)
+
+    # Time for the welcome window
+    mainwindow.guiManager.showWelcomeMessage()
 
     # No need to .exec_ - the reactor takes care of it.
Index: src/sas/qtgui/MainWindow/UnitTesting/GuiManagerTest.py
===================================================================
--- src/sas/qtgui/MainWindow/UnitTesting/GuiManagerTest.py	(revision 53c771ed573b1c8716ecc969b54a1d617a4cb931)
+++ src/sas/qtgui/MainWindow/UnitTesting/GuiManagerTest.py	(revision 8353d908545a5d1d1ac66b2e075d0ec49b5a7cc2)
@@ -19,5 +19,5 @@
 from sas.qtgui.MainWindow.AboutBox import AboutBox
 from sas.qtgui.MainWindow.WelcomePanel import WelcomePanel
-#from sas.qtgui.Utilities.IPythonWidget import IPythonWidget
+from sas.qtgui.Utilities.IPythonWidget import IPythonWidget
 
 from sas.qtgui.MainWindow.GuiManager import Acknowledgements, GuiManager
Index: src/sas/qtgui/MainWindow/UnitTesting/MainWindowTest.py
===================================================================
--- src/sas/qtgui/MainWindow/UnitTesting/MainWindowTest.py	(revision 53c771ed573b1c8716ecc969b54a1d617a4cb931)
+++ src/sas/qtgui/MainWindow/UnitTesting/MainWindowTest.py	(revision 8353d908545a5d1d1ac66b2e075d0ec49b5a7cc2)
@@ -15,4 +15,5 @@
 from sas.qtgui.MainWindow.MainWindow import SplashScreen
 from sas.qtgui.MainWindow.GuiManager import GuiManager
+from sas.qtgui.Perspectives.Fitting import FittingPerspective
 
 if not QtWidgets.QApplication.instance():
@@ -40,4 +41,22 @@
         self.assertIsInstance(splash, QtWidgets.QSplashScreen)
 
+    def testWidgets(self):
+        """ Test enablement/disablement of widgets """
+        # Open the main window
+        tmp_main = MainSasViewWindow(None)
+        tmp_main.showMaximized()
+        # See that only one subwindow is up
+        self.assertEqual(len(tmp_main.workspace.subWindowList()), 1)
+        # and that the subwindow is the fitting perspective
+        self.assertIsInstance(tmp_main.workspace.subWindowList()[0].widget(),
+                              FittingPerspective.FittingWindow)
+        # Show the message widget
+        tmp_main.guiManager.showWelcomeMessage()
+        # Assure it is visible and a part of the MdiArea
+        self.assertTrue(tmp_main.guiManager.welcomePanel.isVisible())
+        self.assertEqual(len(tmp_main.workspace.subWindowList()), 2)
+
+        tmp_main.close()
+
     def testExit(self):
         """