Index: sansmodels/src/python_wrapper/WrapperGenerator.py
===================================================================
--- sansmodels/src/python_wrapper/WrapperGenerator.py	(revision 5da3cc57a0d2568f3d27414a6c82006204b81eca)
+++ sansmodels/src/python_wrapper/WrapperGenerator.py	(revision 8389beb5c2f40e896e91445319bcad17e20a7662)
@@ -44,9 +44,9 @@
         cylinder.h defines the following:
         
-            /// 1D scattering function
-            double cylinder_analytical_1D(CylinderParameters *pars, double q);
-            
-            /// 2D scattering function
-            double cylinder_analytical_2D(CylinderParameters *pars, double q, double phi);
+        /// 1D scattering function
+        double cylinder_analytical_1D(CylinderParameters *pars, double q);
+            
+        /// 2D scattering function
+        double cylinder_analytical_2D(CylinderParameters *pars, double q, double phi);
             
         The .c file implements those functions.
@@ -318,8 +318,10 @@
             The file is written in C[PYTHONCLASS].c
         """
-        file_path = os.path.join(self.c_wrapper_dir, "C"+self.pythonClass+'.cpp')
+        file_path = os.path.join(self.c_wrapper_dir, 
+                                 "C"+self.pythonClass+'.cpp')
         file = open(file_path, 'w')
         
-        template = open(os.path.join(os.path.dirname(__file__), "classTemplate.txt"), 'r')
+        template = open(os.path.join(os.path.dirname(__file__), 
+                                     "classTemplate.txt"), 'r')
         
         tmp_buf = template.read()
@@ -405,12 +407,12 @@
             if self.foundCPP:
                 newline = self.replaceToken(newline, 
-                                            "[C_INCLUDE_FILE]", "")  
+                            "[C_INCLUDE_FILE]", "")  
                 newline = self.replaceToken(newline, 
-                                            "[CPP_INCLUDE_FILE]", "#include \"%s\"" % basename)  
+                            "[CPP_INCLUDE_FILE]", "#include \"%s\"" % basename)  
             else:  
                 newline = self.replaceToken(newline, 
-                                            "[C_INCLUDE_FILE]", "#include \"%s\"" % basename)   
+                            "[C_INCLUDE_FILE]", "#include \"%s\"" % basename)   
                 newline = self.replaceToken(newline, 
-                                            "[CPP_INCLUDE_FILE]", "#include \"models.hh\"")  
+                            "[CPP_INCLUDE_FILE]", "#include \"models.hh\"")  
                 
             # Numerical calcs dealloc
@@ -458,5 +460,6 @@
         file_path = os.path.join(self.output_dir, self.pythonClass+'.py')
         file = open(file_path, 'w')
-        template = open(os.path.join(os.path.dirname(__file__), "modelTemplate.txt"), 'r')
+        template = open(os.path.join(os.path.dirname(__file__), 
+                                     "modelTemplate.txt"), 'r')
         
         tmp_buf = template.read()
@@ -490,10 +493,14 @@
             if self.is_multifunc:
                 newline = self.replaceToken(newline,"[CALL_CPYTHON_INIT]",
-                                            'C' + self.pythonClass + ".__init__(self,multfactor)\n\tself.is_multifunc = True")
-                newline = self.replaceToken(newline,"[MULTIPLICITY_INFO]",self.multiplicity_info)
+                    'C' + self.pythonClass + \
+                    ".__init__(self,multfactor)\n\tself.is_multifunc = True")
+                newline = self.replaceToken(newline,"[MULTIPLICITY_INFO]", 
+                                            self.multiplicity_info)
             else:
                 newline = self.replaceToken(newline,"[CALL_CPYTHON_INIT]",
-                                            'C' + self.pythonClass + ".__init__(self)\n\tself.is_multifunc = False")
-                newline = self.replaceToken(newline,"[MULTIPLICITY_INFO]","None")
+                    'C' + self.pythonClass + \
+                    ".__init__(self)\n        self.is_multifunc = False")
+                newline = self.replaceToken(newline, 
+                                            "[MULTIPLICITY_INFO]","None")
 
            
Index: sansmodels/src/python_wrapper/modelTemplate.txt
===================================================================
--- sansmodels/src/python_wrapper/modelTemplate.txt	(revision 5da3cc57a0d2568f3d27414a6c82006204b81eca)
+++ sansmodels/src/python_wrapper/modelTemplate.txt	(revision 8389beb5c2f40e896e91445319bcad17e20a7662)
@@ -51,5 +51,5 @@
         #apply([CPYTHONCLASS].__init__, (self,)) 
 
-	[CALL_CPYTHON_INIT]
+        [CALL_CPYTHON_INIT]
 		        
         ## Name of the model